Package weka.core.xml

# Class XMLOptions

java.lang.Object
weka.core.xml.XMLOptions

All Implemented Interfaces:
  `RevisionHandler`

public class XMLOptions extends Object implements RevisionHandler
A class for transforming options listed in XML to a regular WEKA command line string.

Version:
  $Revision: 10203 $
Author:
  FracPete (fracpete at waikato dot ac dot nz)

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ATT_NAME`
  the name attribute.
  `static final String`
  `ATT_TYPE`
  the type attribute.
  `static final String`
  `ATT_VALUE`
  the value attribute.
  `static final String`
  `DOCTYPE`
  the DTD for the XML file.
  `static final String`
  `ROOT_NODE`
  the root node.
  `static final String`
  `TAG_OPTION`
  tag for a single option.
  `static final String`
  `TAG_OPTIONS`
  tag for a list of options.
  `static final String`
  `VAL_TYPE_CLASSIFIER`
  a value of the type attribute.
  `static final String`
  `VAL_TYPE_FLAG`
  a value of the type attribute.
  `static final String`
  `VAL_TYPE_HYPHENS`
  a value of the type attribute.
  `static final String`
  `VAL_TYPE_OPTIONHANDLER`
  a value of the type attribute.
  `static final String`
  `VAL_TYPE_QUOTES`
  a value of the type attribute.
  `static final String`
  `VAL_TYPE_SINGLE`
  a value of the type attribute.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `XMLOptions()`
  Creates a new instance of XMLOptions.
  `XMLOptions(File file)`
  Creates a new instance of XMLOptions.
  `XMLOptions(InputStream stream)`
  Creates a new instance of XMLOptions.
  `XMLOptions(Reader reader)`
  Creates a new instance of XMLOptions.
  `XMLOptions(String xml)`
  Creates a new instance of XMLOptions.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Document`
  `getDocument()`
  returns the parsed DOM document.
  `String`
  `getRevision()`
  Returns the revision string.
  `boolean`
  `getValidating()`
  returns whether a validating parser is used.
  `XMLDocument`
  `getXMLDocument()`
  returns the handler of the XML document.
  `static void`
  `main(String[] args)`
  for testing only.
  `void`
  `setValidating(boolean validating)`
  sets whether to use a validating parser or not.
  `String[]`
  `toArray()`
  returns the current DOM document as string array.
  `String`
  `toCommandLine()`
  returns the given DOM document as command line.
  `String`
  `toString()`
  returns the object in a string representation (as indented XML output).

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### TAG_OPTION

    public static final String TAG_OPTION
    tag for a single option.
    See Also:
      - Constant Field Values

  - ### TAG_OPTIONS

    public static final String TAG_OPTIONS
    tag for a list of options.
    See Also:
      - Constant Field Values

  - ### ATT_NAME

    public static final String ATT_NAME
    the name attribute.
    See Also:
      - Constant Field Values

  - ### ATT_TYPE

    public static final String ATT_TYPE
    the type attribute.
    See Also:
      - Constant Field Values

  - ### ATT_VALUE

    public static final String ATT_VALUE
    the value attribute.
    See Also:
      - Constant Field Values

  - ### VAL_TYPE_FLAG

    public static final String VAL_TYPE_FLAG
    a value of the type attribute.
    See Also:
      - Constant Field Values

  - ### VAL_TYPE_SINGLE

    public static final String VAL_TYPE_SINGLE
    a value of the type attribute.
    See Also:
      - Constant Field Values

  - ### VAL_TYPE_HYPHENS

    public static final String VAL_TYPE_HYPHENS
    a value of the type attribute.
    See Also:
      - Constant Field Values

  - ### VAL_TYPE_QUOTES

    public static final String VAL_TYPE_QUOTES
    a value of the type attribute.
    See Also:
      - Constant Field Values

  - ### VAL_TYPE_CLASSIFIER

    public static final String VAL_TYPE_CLASSIFIER
    a value of the type attribute.
    See Also:
      - Constant Field Values

  - ### VAL_TYPE_OPTIONHANDLER

    public static final String VAL_TYPE_OPTIONHANDLER
    a value of the type attribute.
    See Also:
      - Constant Field Values

  - ### ROOT_NODE

    public static final String ROOT_NODE
    the root node.
    See Also:
      - Constant Field Values

  - ### DOCTYPE

    public static final String DOCTYPE
    the DTD for the XML file.
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### XMLOptions

    public XMLOptions() throws Exception
    Creates a new instance of XMLOptions.
    Throws:
      `Exception` - if the construction of the DocumentBuilder fails
    See Also:
      - `setValidating(boolean)`

  - ### XMLOptions

    public XMLOptions(String xml) throws Exception
    Creates a new instance of XMLOptions.
    Parameters:
      `xml` - the xml to parse (if "<?xml" is not found then it is considered a file)
    Throws:
      `Exception` - if the construction of the DocumentBuilder fails
    See Also:
      - `setValidating(boolean)`

  - ### XMLOptions

    public XMLOptions(File file) throws Exception
    Creates a new instance of XMLOptions.
    Parameters:
      `file` - the XML file to parse
    Throws:
      `Exception` - if the construction of the DocumentBuilder fails
    See Also:
      - `setValidating(boolean)`

  - ### XMLOptions

    public XMLOptions(InputStream stream) throws Exception
    Creates a new instance of XMLOptions.
    Parameters:
      `stream` - the XML stream to parse
    Throws:
      `Exception` - if the construction of the DocumentBuilder fails
    See Also:
      - `setValidating(boolean)`

  - ### XMLOptions

    public XMLOptions(Reader reader) throws Exception
    Creates a new instance of XMLOptions.
    Parameters:
      `reader` - the XML reader to parse
    Throws:
      `Exception` - if the construction of the DocumentBuilder fails
    See Also:
      - `setValidating(boolean)`

- ## Method Details

  - ### getValidating

    public boolean getValidating()
    returns whether a validating parser is used.
    Returns:
      whether a validating parser is used

  - ### setValidating

    public void setValidating(boolean validating) throws Exception
    sets whether to use a validating parser or not.
    Note: this does clear the current DOM document!
    Parameters:
      `validating` - whether to use a validating parser
    Throws:
      `Exception` - if the instantiating of the DocumentBuilder fails

  - ### getDocument

    public Document getDocument()
    returns the parsed DOM document.
    Returns:
      the parsed DOM document

  - ### getXMLDocument

    public XMLDocument getXMLDocument()
    returns the handler of the XML document. the internal DOM document can be accessed via the `getDocument()` method.
    Returns:
      the object handling the XML document
    See Also:
      - `getDocument()`

  - ### toCommandLine

    public String toCommandLine() throws Exception
    returns the given DOM document as command line.
    Returns:
      the document as command line
    Throws:
      `Exception` - if anything goes wrong initializing the parsing

  - ### toArray

    public String[] toArray() throws Exception
    returns the current DOM document as string array.
    Returns:
      the document as string array
    Throws:
      `Exception` - if anything goes wrong initializing the parsing

  - ### toString

    public String toString()
    returns the object in a string representation (as indented XML output).
    Overrides:
      `toString` in class `Object`
    Returns:
      the object in a string representation

  - ### getRevision

    public String getRevision()
    Returns the revision string.
    Specified by:
      `getRevision` in interface `RevisionHandler`
    Returns:
      the revision

  - ### main

    public static void main(String[] args) throws Exception
    for testing only. prints the given XML file, the resulting commandline and the string array.
    Parameters:
      `args` - the commandline options.
    Throws:
      `Exception` - if something goes wrong